SystemOrganization addCategory: #TAdP!
SystemOrganization addCategory: #'TAdP-Tests'!

Trait named: #TraitConsumoCable
	uses: {}
	category: 'TAdP'!

!TraitConsumoCable methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:41'!
consumo:unPanel
	^unPanel consumo * (self getAumento)! !

!TraitConsumoCable methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:43'!
getAumento
	self requirement.! !

Trait named: #TraitHzCable
	uses: {}
	category: 'TAdP'!

!TraitHzCable methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 19:13'!
getHz
	^self class getHz.! !

Trait named: #TraitPanelConsumo
	uses: {}
	category: 'TAdP'!

!TraitPanelConsumo methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:36'!
consumo
	^(self getPotencia * self getTamanio).! !

!TraitPanelConsumo methodsFor: 'as yet unclassified' stamp: 'joseflores 4/18/2013 02:11'!
getPotencia
	^self requirement.! !

!TraitPanelConsumo methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:00'!
getTamanio
	^self requirement.! !

Trait named: #TraitPanelDefinicion
	uses: {}
	category: 'TAdP'!

!TraitPanelDefinicion methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:37'!
definicion
	^(self getPPP * ((self getTamanio raisedTo: 2) / 2) sqrt).
	! !

!TraitPanelDefinicion methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:22'!
getPPP
	self requirement.
	! !

!TraitPanelDefinicion methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:21'!
getTamanio
	self requirement.
	! !

Trait named: #TraitRealGPU
	uses: {}
	category: 'TAdP'!

!TraitRealGPU methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 20:28'!
getAlto
	self requirement.! !

!TraitRealGPU methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 20:28'!
getAncho
	self requirement.! !

!TraitRealGPU methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 20:30'!
resolucionMaxima
	^self getAncho * self getAlto.! !

!TraitRealGPU methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 20:30'!
resolucionReal:unProducto
	^(unProducto resolucionPermitida min: self resolucionMaxima).! !

TestCase subclass: #CableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP-Tests'!

!CableTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 03:24'!
testAumentoHDMI
"Mejorar este caso, no se debera poder enchufar un CRT con HDMI...creo"
	| unCableHdmi unPanel |
	unCableHdmi:= HDMI new.
	unPanel:= CRT new.
	unPanel setPotencia: 1.
	unPanel setTamanio: 40.
	
	self assert:(1.2= unCableHdmi getAumento).
	self assert: (48 = (unCableHdmi consumo: unPanel)).! !

!CableTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 03:16'!
testAumentoVGA
	| unCableVga unPanel |
	unPanel:= CRT new.
	unPanel setPotencia: 1.
	unPanel setTamanio: 40.
	
	unCableVga:= VGA new.
	unCableVga setDefinicion: 480.
	
	self assert:(0.48= unCableVga getAumento).
	self assert: (230 = (unCableVga consumo: unPanel) floor).! !

TestCase subclass: #ComputadoraTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP-Tests'!

TestCase subclass: #PanelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP-Tests'!

!PanelTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 14:23'!
testConsumoLED
	| unPanel |
	unPanel  := LED new.
	unPanel setTamanio: 32.
	unPanel setPotencia: 1.
		
	self assert: (32 = unPanel consumo)! !

!PanelTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:25'!
testDefMaxCRT
	| unPanel |
	unPanel  := CRT new.
	unPanel setTamanio: 32.
	
	self assert: (480= unPanel definicion)! !

!PanelTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 14:24'!
testDefMaxLED
	| unPanel |
	unPanel  := LED new.
	unPanel setTamanio: 32.
	unPanel setPPP:85.
	
	self assert:(1923 = unPanel definicion floor)! !

TestCase subclass: #ProductoTest
	instanceVariableNames: 'unProducto unPanel unCable unaTV unMonitor'
	classVariableNames: 'Argument'
	poolDictionaries: ''
	category: 'TAdP-Tests'!

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 14:28'!
setUp
	unaTV := TV new.
	unPanel  := LED new.
	unPanel setPotencia: 1.
	unPanel setTamanio: 42.
	unPanel setPPP:85.
	
	unCable := VGA new.
	unCable 	setDefinicion:480.	
	
	unaTV setPanel: unPanel.
	unaTV setCable: unCable.
	
	unProducto := Producto new.
	unProducto setPanel: unPanel.
	unProducto setCable: unCable.
! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 14:47'!
testCableMuchaDefinicionConPantallaPobre	
	unCable:=HDMI new.
	unPanel  := CRT new.
	unPanel setPotencia: 5.
	unPanel setTamanio: 29.
	
	unCable setDefinicion: 1080.
		
	unaTV setPanel: unPanel.
	unaTV setCable: unCable.
	self shouldnt:[unaTV sePuedeConectar:unCable].! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 14:41'!
testCablePocaDefinicionConPantallaGrosa	
	unCable:=AV new.
	self should:[unaTV sePuedeConectar:unCable].! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 14:35'!
testConsumoDeUnMonitorLEDConVGA
	unMonitor := Moni new.
	unPanel setTamanio: 17.
	unPanel setPPP:100.
		
	unCable 	setDefinicion:720.	
	
	unMonitor setPanel: unPanel.
	unMonitor setCable: unCable.
	
	self assert:(17 = unPanel consumo).
	self assert:(535 = unMonitor consumo floor).! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 14:34'!
testConsumoDeUnProductoLCDConHDMI
	unPanel  := LCD new.
	unCable := HDMI new.
	unPanel setPotencia: 4.
	unPanel setTamanio: 42.
	unPanel setPPP:85.
		
	unProducto setPanel: unPanel.
	unProducto setCable: unCable.
	
	self assert:(168 = unPanel consumo).
	self assert:(369 = unProducto consumo floor).! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 14:33'!
testConsumoDeUnProductoLEDConHDMI
	unCable := HDMI new.
	unProducto setCable: unCable.
	
	unPanel setPPP:100.
	
	self assert:(42 = unPanel consumo).
	self assert:(92 = unProducto consumo floor).! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 14:28'!
testConsumoDeUnProductoLEDConVGA
	unPanel setPPP:204.
	unCable 	setDefinicion:720.	
	
	self assert:(42 = unPanel consumo).
	self assert:(560 = unProducto consumo floor).! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/20/2013 01:26'!
testResolucionMaximaDeUnaTvLEDConVGA
	self assert:(129600 = unaTV resolucionPermitida).! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 18:08'!
testUnCRTConVGAEsMaloParaViciar
	unPanel  := CRT new.
	unPanel setPotencia: 5.
	unPanel setTamanio: 29.

	unaTV setPanel: unPanel.
		
	self assert: unaTV esAptoParaJugar not.! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 23:11'!
testUnLEDMonitorConVGAEsBuenoParaViciar
	unMonitor:=Moni new.
	unMonitor setPanel:unPanel.
	unMonitor setCable:unCable.
	
	self assert: unMonitor esAptoParaJugar not.! !

!ProductoTest methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 22:59'!
testUnLEDTVConVGAEsBuenoParaViciar
	self assert: unaTV esAptoParaJugar not.! !

Object subclass: #Cable
	instanceVariableNames: 'hz definicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!Cable commentStamp: '<historical>' prior: 0!
A Cable is xxxxxxxxx.

Instance Variables
	definicion:		<Object>
	hz:		<Object>

definicion
	- xxxxx

hz
	- xxxxx
!

Cable subclass: #AV
	uses: TraitConsumoCable
	instanceVariableNames: ''
	classVariableNames: 'aumento'
	poolDictionaries: ''
	category: 'TAdP'!

!AV commentStamp: '<historical>' prior: 0!
An AV is xxxxxxxxx.

Instance Variables
!

AV class
	uses: TraitConsumoCable classTrait
	instanceVariableNames: ''!

!AV class methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:42'!
getAumento
	^aumento.! !

!AV class methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 03:11'!
getDefinicion
	^480.! !

!AV methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:41'!
getAumento
	^self class getAumento.! !

!AV methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 03:11'!
getDefinicion
	^self class getDefinicion.! !

!AV methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 18:04'!
getHz
	hz isNil ifTrue:[ hz:=50 ].
	^hz.! !

!Cable methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:53'!
getDefinicion
	^definicion.! !

!Cable methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:53'!
getHz
	^hz.! !

!Cable methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 02:40'!
setDefinicion:unaDefinicion
	definicion:=unaDefinicion.! !

Cable subclass: #HDMI
	uses: TraitConsumoCable
	instanceVariableNames: ''
	classVariableNames: 'aumento'
	poolDictionaries: ''
	category: 'TAdP'!

!HDMI commentStamp: '<historical>' prior: 0!
A HDMI is xxxxxxxxx.

Instance Variables
!

HDMI class
	uses: TraitConsumoCable classTrait
	instanceVariableNames: ''!

!HDMI class methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 01:17'!
getAumento
	^1.2.! !

!HDMI methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:42'!
getAumento
	^self class getAumento.! !

!HDMI methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 18:05'!
setHz:unHz
	hz:=unHz.
! !

Cable subclass: #RF
	uses: TraitConsumoCable
	instanceVariableNames: ''
	classVariableNames: 'aumento'
	poolDictionaries: ''
	category: 'TAdP'!

!RF commentStamp: '<historical>' prior: 0!
A RF is xxxxxxxxx.

Instance Variables
!

RF class
	uses: TraitConsumoCable classTrait
	instanceVariableNames: ''!

!RF class methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 01:16'!
getAumento
	^0.! !

!RF class methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 03:12'!
getDefinicion
	^480.
! !

!RF methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:42'!
getAumento
	^self class getAumento.! !

!RF methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 03:12'!
getDefinicion
	^self class getDefinicion.! !

!RF methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 18:05'!
getHz
	hz isNil ifTrue:[ hz:=50 ].
	^hz.! !

Cable subclass: #VGA
	instanceVariableNames: 'aumento'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!VGA commentStamp: '<historical>' prior: 0!
A VGA is xxxxxxxxx.

Instance Variables
!

!VGA methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:59'!
consumo:unPanel
	^(self getAumento * ((unPanel definicion) min: (self getDefinicion))).! !

!VGA methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 02:44'!
getAumento
	^self getDefinicion * 0.001.! !

!VGA methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 03:07'!
getDefinicion
	^definicion.! !

!VGA methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 18:05'!
getHz
	hz isNil ifTrue:[ hz:=120 ].
	^hz.! !

Object subclass: #Computadora
	instanceVariableNames: 'imagen video disco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!Computadora commentStamp: '<historical>' prior: 0!
A Computadora is xxxxxxxxx.

Instance Variables
	disco:		<Object>
	imagen:		<Object>
	video:		<Object>

disco
	- xxxxx

imagen
	- xxxxx

video
	- xxxxx
!

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 23:03'!
consumo
	^(self getDisco consumo) + (self getImagen consumo) + (self getVideo consumo:(self getImagen)).! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 20:13'!
esAptaParaJugar
	^(self getImagen esAptoParaJugar) & (self getVideo esApta:(self getImagen)).! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 23:00'!
getDisco
	^disco.! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:59'!
getImagen
	^imagen.! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 23:00'!
getVideo
	^video.! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 19:56'!
setDisco:unDisco.
	disco := unDisco.! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 19:56'!
setImagen:unaPantalla
	^imagen := unaPantalla.! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 19:55'!
setVideo:unaPlaca
	video :=unaPlaca.! !

Object subclass: #Disco
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

Disco subclass: #DiscoEstadoSolido
	instanceVariableNames: 'consumoFijo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!DiscoEstadoSolido commentStamp: '<historical>' prior: 0!
A DiscoEstadoSolido is xxxxxxxxx.

Instance Variables
	consumoFijo:		<Object>

consumoFijo
	- xxxxx
!

!DiscoEstadoSolido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:32'!
consumo
	^self getConsumo.! !

!DiscoEstadoSolido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:32'!
getConsumo
	^consumoFijo.! !

!DiscoEstadoSolido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:32'!
setConsumo:unValor
	consumoFijo := unValor.! !

Disco subclass: #DiscoRigido
	instanceVariableNames: 'rpm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!DiscoRigido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:31'!
consumo
	^self getRpm * 60 / 1000.! !

!DiscoRigido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:30'!
getRpm
	^rpm.! !

!DiscoRigido methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:30'!
setRpm:unValor
	rpm := unValor.! !

Object subclass: #GPU
	instanceVariableNames: 'coolers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!GPU methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:06'!
consumoCoolers! !

!GPU methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:12'!
consumoGPU:unProducto
	^self consumo:unProducto + self consumoCoolers.! !

!GPU methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:07'!
getCoolers
	^coolers.! !

!GPU methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:09'!
setCoolers:unValor
	coolers := unValor.! !

GPU subclass: #GPUBasica
	instanceVariableNames: 'consumoPromedio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!GPUBasica methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:12'!
consumo:unProducto
	^((self resolucionReal:unProducto) logaritmo / self getConsumoPromedio).! !

!GPUBasica methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:50'!
esApta:unProducto
	^((unProducto resolucionPermitida * (unProducto resolucionPermitida * 9 / 16) ) / self getConsumoPromedio) > 4.
	
	! !

!GPUBasica methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:56'!
getConsumoPromedio
	^consumoPromedio.! !

!GPUBasica methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:02'!
resolucionReal:unProducto
	^unProducto resolucionPermitida.! !

!GPUBasica methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:56'!
setConsumoPromedio:unValor
	consumoPromedio := unValor.! !

GPU subclass: #GPUModerna
	instanceVariableNames: 'ancho alto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!GPUModerna methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:00'!
consumo:unProducto
	^self resolucionReal:unProducto / 100000.! !

!GPUModerna methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:48'!
esApta:unProducto.
	^true.! !

!GPUModerna methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 23:50'!
resolucionMaxima
	^self getAncho * self getAlto.! !

!GPUModerna methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:00'!
resolucionReal:unProducto
	^(unProducto resolucionPermitida min: self resolucionMaxima).! !

GPU subclass: #GPUOnboard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!GPUOnboard methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 00:14'!
consumo:unProducto
	^self getConsumoPromedio.! !

!GPUOnboard methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:48'!
esApta:unProducto
	^false.! !

Object subclass: #Panel
	instanceVariableNames: 'potencia tamanio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

Panel subclass: #CRT
	uses: TraitPanelConsumo
	instanceVariableNames: ''
	classVariableNames: 'definicionMax'
	poolDictionaries: ''
	category: 'TAdP'!

CRT class
	uses: TraitPanelConsumo classTrait
	instanceVariableNames: ''!

!CRT class methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:49'!
definicion
	^self class definicionMaxima.! !

!CRT class methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 00:25'!
getDefinicionMaxima
	definicionMax isNil ifTrue: [definicionMax:=480].
	^definicionMax.! !

!CRT class methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 19:38'!
getPotencia
	^5.! !

!CRT methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:51'!
definicion
	^self class getDefinicionMaxima.! !

Panel subclass: #LCD
	uses: TraitPanelConsumo + TraitPanelDefinicion
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

LCD class
	uses: TraitPanelConsumo classTrait + TraitPanelDefinicion classTrait
	instanceVariableNames: ''!

!LCD methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:52'!
getPPP
	^ppp.! !

!LCD methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:52'!
setPPP:unValor
	ppp := unValor.! !

Panel subclass: #LED
	uses: TraitPanelConsumo + TraitPanelDefinicion
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

LED class
	uses: TraitPanelConsumo classTrait + TraitPanelDefinicion classTrait
	instanceVariableNames: ''!

!LED class methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 19:38'!
getPotencia
	^1.! !

!LED methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:53'!
getPPP
	^ppp.! !

!LED methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:53'!
setPPP:unValor
	ppp := unValor.! !

!Panel methodsFor: 'Getter/Setter' stamp: 'Nico 4/19/2013 19:37'!
getPotencia
	^self class getPotencia.! !

!Panel methodsFor: 'Getter/Setter' stamp: 'joseflores 4/18/2013 08:25'!
getTamanio
	^tamanio.! !

!Panel methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:51'!
setPotencia:unValor
	potencia := unValor.! !

!Panel methodsFor: 'Getter/Setter' stamp: 'Nicolas 4/14/2013 21:51'!
setTamanio:unValor
	tamanio := unValor.! !

Object subclass: #Producto
	instanceVariableNames: 'cable panel'
	classVariableNames: 'hz'
	poolDictionaries: ''
	category: 'TAdP'!

Producto subclass: #Moni
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!Moni class methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 19:44'!
getHz
	^120.! !

!Producto class methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:27'!
getHz
	^hz.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'joseflores 4/18/2013 22:07'!
consumo
	^((self getCable consumo:((self getPanel))) + ((self getPanel) consumo)).! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 20:40'!
esAptoElCableParaLaPantalla
	^self getPanel definicion >= self getCable getDefinicion.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 22:57'!
esAptoParaJugar
	^self tasaDeRefrescoReal >= 100.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'joseflores 4/18/2013 01:57'!
getCable
	^cable.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:27'!
getHz
	^self class getHz.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'joseflores 4/18/2013 01:57'!
getPanel
	^panel.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 20:03'!
resolucionPermitida
|definicion|
	definicion := (self getCable getDefinicion) min: (self getPanel definicion).
	^definicion * (definicion / 16 * 9).! !

!Producto methodsFor: 'as yet unclassified' stamp: 'joseflores 4/19/2013 14:46'!
sePuedeConectar:unCable
	^((unCable getDefinicion) < (self getPanel definicion)).! !

!Producto methodsFor: 'as yet unclassified' stamp: 'joseflores 4/18/2013 01:55'!
setCable:unCable
	cable:= unCable.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:25'!
setHz:unValor
	hz := unValor.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:19'!
setPanel:unPanel
	panel := unPanel.! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/15/2013 21:58'!
tasaDeRefrescoReal
	^(self class getHz) min: (self getCable getHz).! !

Producto subclass: #TV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

TV subclass: #SmartTV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!SmartTV methodsFor: 'as yet unclassified' stamp: 'Nicolas 4/14/2013 22:28'!
getHz
	^self super class getHz * 1,5.! !

!TV class methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 19:45'!
getHz
	^90.! !

Object subclass: #Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TAdP'!

!Test methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 20:38'!
testCableAptoParaLaPantalla
	|panel pantalla entrada|
	panel := LCD new.
	pantalla := SmartTV new.
	entrada := VGA new.
	panel setPPP:100.
	panel setTamanio:17.
	entrada setDefinicion:720.
	
	pantalla setPanel: panel.
	pantalla setCable:entrada.
	pantalla esAptoElCableParaLaPantalla.! !

!Test methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 20:09'!
testComputadoraAptaParaJugar
	|panel pantalla entrada computadora placa disco|
	panel := LCD new.
	pantalla := SmartTV new.
	entrada := VGA new.
	computadora := Computadora new.
	placa := GPUModerna new.
	disco := DiscoRigido new.
	
	
	panel setPPP:100.
	panel setTamanio:17.
	entrada setDefinicion:720.
	pantalla setPanel: panel.
	pantalla setCable:entrada.
	
	disco setRpm:7200.
	
	placa setCoolers:2.
	placa setAncho: 2500 yAlto: 1600.
	
	computadora setImagen:pantalla.
	computadora setDisco: disco.
	computadora setVideo: placa.
	
	
	computadora esAptaParaJugar.! !

!Test methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 19:47'!
testConfiguracionEntradaPantallaApta
	|panel pantalla entrada|
	panel := LCD new.
	pantalla := SmartTV new.
	entrada := VGA new.
	panel setPPP:100.
	panel setTamanio:17.
	entrada setDefinicion:720.
	
	pantalla setPanel: panel.
	pantalla setCable:entrada.
	pantalla esAptoParaJugar.! !

!Test methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 20:06'!
testConsumoComputadora
	|panel pantalla entrada computadora placa disco|
	panel := LCD new.
	pantalla := SmartTV new.
	entrada := VGA new.
	computadora := Computadora new.
	placa := GPUModerna new.
	disco := DiscoRigido new.
	
	
	panel setPPP:100.
	panel setTamanio:17.
	entrada setDefinicion:720.
	pantalla setPanel: panel.
	pantalla setCable:entrada.
	
	disco setRpm:7200.
	
	placa setCoolers:2.
	placa setAncho: 2500 yAlto: 1600.
	
	computadora setImagen:pantalla.
	computadora setDisco: disco.
	computadora setVideo: placa.
	
	
	computadora consumo.! !

!Test methodsFor: 'as yet unclassified' stamp: 'Nico 4/19/2013 19:31'!
testConsumoEnergiaPantalla
	|panel pantalla entrada|
	panel := LCD new.
	pantalla := Moni new.
	entrada := VGA new.
	panel setPPP:100.
	panel setTamanio:17.
	entrada setDefinicion:720.
	
	pantalla setPanel: panel.
	pantalla setCable:entrada.
	pantalla consumo.! !
